// ----------------------------------------------------
/*
   class CIconeFactory

   Author :   Sylvain Lefebvre
   Created:   06/11/2002

 */
// ----------------------------------------------------
#ifndef __CICONFACTORY_H_
#define __CICONFACTORY_H_
// ----------------------------------------------------
#include <vector>
#include "CException.h"
// ----------------------------------------------------
#include "CIcon.h"
// ----------------------------------------------------
class CIconFactory
{

private:

  static std::vector<CIcon *> m_Icons;

public:

  static char * m_dataDir;
	
  static void createIcons();

  static CIcon *getIcon(int i)
    {
      createIcons();
      if (i < 0 || i >= (int)m_Icons.size())
	throw CException("Acces violation on icon (%d) [0 %d]",i,m_Icons.size());
      return (m_Icons[i]);
    }

  static int getNbIcons()
    {
      createIcons();
      return (m_Icons.size());
    }

};
// ----------------------------------------------------
#endif
// ----------------------------------------------------
