# This file should be viewed as a -*- mode: Makefile -*-


include(../mobinet.pri)

SOURCES	+=	CWorld.cpp       \
			CInterface.cpp   \
			CVertex.cpp      \
			CViewer.cpp      \
			CMobile.cpp      \
			CalcLexer.cpp    \
			CalcParser.cpp   \
			CalcWalker.cpp   \
			CIconFactory.cpp \
			icones.cpp       \
			UDistance.cpp    \
			MyASTNode.cpp    \
			main.cpp


!isEmpty(HANDLE_GRAMMAR) {
    calc.target		=	CalcParser.cpp
    calc.commands	=	java antlr.Tool calc.g
    calc.depends	=	calc.g

    calc2.target	=	CalcLexer.cpp
    calc2.depends	=	CalcParser.cpp

    calc3.target	=	CalcLexer.hpp
    calc3.depends	=	CalcLexer.cpp

    calc4.target	=	CalcParser.hpp
    calc4.depends	=	CalcParser.cpp

    calc5.target	=	CalcWalker.hpp
    calc5.depends	=	CalcWalker.cpp

    calc6.target	=	CalcWalker.cpp
    calc6.depends	=	CalcParser.cpp

    QMAKE_EXTRA_UNIX_TARGETS	+=	calc6 calc5 calc4 calc3 calc2 calc calcMsg

    #system(echo "     Taking calc.g modifs into account")
}

HEADERS	+=	CWorld.h           \
                  CViewer.h          \
			CIconFactory.h     \
			CIcon.h		 \ 
			CInterface.h       \
			CReceiver.h        \
			CMobile.h          \
			CException.h       \
			CReceiver.h        \
			CVertex.h          \
			CVertex.inl        \
			icones.h           \
			UDistance.h	       \
			MyASTNode.h        \
			messages.h         \
			messages_calc.h    \
			messages_CVertex.h \
			messages_CMobile.h \
			messages_CInterface.h \
			messages_CWorld.h  \
			messages_CViewer.h  \
			CalcLexer.hpp      \
			CalcParser.hpp     \
			CalcWalker.hpp     



Makefile.target		=	Makefile
Makefile.commands	=	qmake 
!isEmpty(IMAGIS) {
    Makefile.commands	+=	IMAGIS=1
}
!isEmpty(HANDLE_GRAMMAR) {
    Makefile.commands	+=	HANDLE_GRAMMAR=1
}
Makefile.depends	=	../mobinet.pri

TARGET		=	mobinet
unix:DESTDIR	=	../bin/linux
win32:DESTDIR	=	../bin/win32
macx:DESTDIR	=	../bin/OS-X


win32 : FORMS3	= main_interface.ui 
unix : FORMS	= main_interface.ui 

TEMPLATE	=	app 


CONFIG	+=	uic3 general qt opengl thread
QT		+=	opengl qt3support xml
macx : LIBS += -framework QtCore -framework QtXml -framework QtSql -framework Qt3Support


isEmpty(DEBUG) {
    CONFIG	+= release
}
!isEmpty(DEBUG) {
    CONFIG	+= debug
}

DBFILE		=	mobile.db
LANGUAGE	=	C++

unix : LIBS	+=	-lglut
win32 : LIBS	+=	-lglut32
macx|darwin-g++ {
  # GLUT for Macintosh architecture
    QMAKE_LIBS -= -lglut
    QMAKE_LIBS *= -framework GLUT -lobjc

	# copie des donnees dans le bundle mobinet.app
	mobiles.path = $$DESTDIR/$${TARGET}.app/Contents
	mobiles.files = ../mobiles
	INSTALLS += mobiles 

	data.path = $$DESTDIR/$${TARGET}.app/Contents
	data.files = ../data
	INSTALLS += data

	presets.path = $$DESTDIR/$${TARGET}.app/Contents
	presets.files = ../presets
	INSTALLS += presets  


	# copies des libs dans le bundle mobinet.app
	QMAKE_LDFLAGS += -headerpad_max_install_names
	libs.path = $$DESTDIR/$${TARGET}.app/Contents/Libraries
	libs.files =	$${QGLVIEWER_LIB_PATH}/QGLViewer.framework/Versions/2/QGLViewer \
			$${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore \
			$${QMAKE_LIBDIR_QT}/QtXml.framework/Versions/4/QtXml \
			$${QMAKE_LIBDIR_QT}/QtGui.framework/Versions/4/QtGui \
			$${QMAKE_LIBDIR_QT}/QtSql.framework/Versions/4/QtSql \
			$${QMAKE_LIBDIR_QT}/Qt3Support.framework/Versions/4/Qt3Support\
			$${QMAKE_LIBDIR_QT}/QtNetwork.framework/Versions/4/QtNetWork \
			$${QMAKE_LIBDIR_QT}/QtOpenGL.framework/Versions/4/QtOpenGL\
			$${SDL_LIB_PATH}/libSDL-1.2.0.dylib \
			$${SDL_LIB_PATH}/libSDL_net-1.2.0.dylib \
			$${JPEG_LIB_PATH}/libjpeg.62.dylib
	INSTALLS += libs

	# redirection des liens vers les libs dynamiques
	patch.path = $$DESTDIR/$${TARGET}.app/Contents/Libraries

	patch.extra += install_name_tool -change $${SDL_LIB_PATH}/libSDL-1.2.0.dylib  				@executable_path/../Libraries/libSDL-1.2.0.dylib \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/libSDL_net-1.2.0.dylib ;

	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/QtGui ;
	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/QtXml ;
	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/QtSql ;
	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
					 -change $${QMAKE_LIBDIR_QT}/QtGui.framework/Versions/4/QtGui  			@executable_path/../Libraries/QtGui \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/QtOpenGL ;
	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
 					 -change $${QMAKE_LIBDIR_QT}/QtSql.framework/Versions/4/QtSql			@executable_path/../Libraries/QtSql \
					 -change $${QMAKE_LIBDIR_QT}/QtXml.framework/Versions/4/QtXml  			@executable_path/../Libraries/QtXml \
					 -change $${QMAKE_LIBDIR_QT}/QtNetwork.framework/Versions/4/QtNetwork		@executable_path/../Libraries/QtNetwork \
					 -change $${QMAKE_LIBDIR_QT}/QtGui.framework/Versions/4/QtGui  			@executable_path/../Libraries/QtGui \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/Qt3Support ;
	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/QtNetwork ;
	patch.extra += install_name_tool -change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore  		@executable_path/../Libraries/QtCore \
					 -change $${QMAKE_LIBDIR_QT}/QtXml.framework/Versions/4/QtXml  			@executable_path/../Libraries/QtXml \
					 -change $${QMAKE_LIBDIR_QT}/QtGui.framework/Versions/4/QtGui  			@executable_path/../Libraries/QtGui \
					 -change $${QMAKE_LIBDIR_QT}/QtOpenGL.framework/Versions/4/QtOpenGL  		@executable_path/../Libraries/QtOpenGL \
					$$DESTDIR/$${TARGET}.app/Contents/Libraries/QGLViewer ;



	patch.extra += install_name_tool -change $${SDL_LIB_PATH}/libSDL-1.2.0.dylib 				@executable_path/../Libraries/libSDL-1.2.0.dylib \
					-change $${SDL_LIB_PATH}/libSDL_net-1.2.0.dylib 			@executable_path/../Libraries/libSDL_net-1.2.0.dylib \
					-change $${JPEG_LIB_PATH}/libjpeg.62.dylib 				@executable_path/../Libraries/libjpeg.62.dylib \
					-change QGLViewer.framework/Versions/2/QGLViewer			@executable_path/../Libraries/QGLViewer \
					-change $${QMAKE_LIBDIR_QT}/QtCore.framework/Versions/4/QtCore		@executable_path/../Libraries/QtCore \
					-change $${QMAKE_LIBDIR_QT}/QtXml.framework/Versions/4/QtXml		@executable_path/../Libraries/QtXml \
					-change $${QMAKE_LIBDIR_QT}/QtGui.framework/Versions/4/QtGui		@executable_path/../Libraries/QtGui \
					-change $${QMAKE_LIBDIR_QT}/QtSql.framework/Versions/4/QtSql		@executable_path/../Libraries/QtSql \
					-change $${QMAKE_LIBDIR_QT}/Qt3Support.framework/Versions/4/Qt3Support	@executable_path/../Libraries/Qt3Support \
					-change $${QMAKE_LIBDIR_QT}/QtNetwork.framework/Versions/4/QtNetwork	@executable_path/../Libraries/QtNetwork \
					-change $${QMAKE_LIBDIR_QT}/QtOpenGL.framework/Versions/4/QtOpenGL	@executable_path/../Libraries/QtOpenGL \
					$$DESTDIR/$${TARGET}.app/Contents/MacOS/$${TARGET} ;

	INSTALLS += patch

  # Qt3 only
  macx: CONFIG -= thread
}


# librairie libnetghost
INCLUDEPATH	+=	../lib/src/libnetghost
QMAKE_LIBDIR 	+= 	$$EXTLIB_PATH
LIBS		+=	-lNetGhost

#librarie libpersist
INCLUDEPATH	+=	../lib/src/persist
QMAKE_LIBDIR 	+= 	$$EXTLIB_PATH
LIBS		+=	-lPersistXml

# librairie libtexture
INCLUDEPATH	+=	../lib/src/libtexture
QMAKE_LIBDIR 	+= 	$$EXTLIB_PATH
LIBS		+=	-lTexture

# librairie XML
INCLUDEPATH	+= 	$$XML2_INC_PATH 
QMAKE_LIBDIR += $$XML2_LIB_PATH
unix : LIBS		+=	-lxml2
win32: LIBS		+=	-llibxml2

# librairie ANTLR
INCLUDEPATH	+=	$$ANTLR_INC_PATH
QMAKE_LIBDIR += $$ANTLR_LIB_PATH
LIBS		+=	-lantlr

# librarie SDL 
INCLUDEPATH	+=	$$SDL_INC_PATH
QMAKE_LIBDIR += $$SDL_LIB_PATH
LIBS		+= -L$$SDL_LIB_PATH	-lSDL -lSDL_net -lSDLmain

#librairie jpeg
QMAKE_LIBDIR += $$JPEG_LIB_PATH 
LIBS   += -ljpeg

#iconv
INCLUDEPATH	+=	$$ICONV_INC_PATH

#QGLViewer
INCLUDEPATH	+=	$$QGLVIEWER_INC_PATH
QMAKE_LIBDIR += $$QGLVIEWER_LIB_PATH
unix: LIBS		+=	-lQGLViewer
win32: LIBS		+=	-lQGLViewer2
macx : LIBS		+= 	-framework QGLViewer

DEPENDPATH	*=	$$INCLUDEPATH

#icone
win32: RC_FILE = mobinet.rc